#include		"dlogUtils.h"
#include		"cntlUtils.h"
#include		"qdUtils.h"

short		getDlogItemType(DialogRef d, short i)
{
	short		t;
	Handle		h;
	Rect			r;
	
	GetDialogItem(d, i, &t, &(Handle)h, &r);
	
	return t;
}

Handle	getDlogItemHandle(DialogRef d, short i)
{
	short		t;
	Handle		h;
	Rect			r;
	
	GetDialogItem(d, i, &t, &(Handle)h, &r);
	
	return h;
}

void	getDlogItemRect(DialogRef d, short i, Rect *r)
{
	short		t;
	Handle		h;
	
	GetDialogItem(d, i, &t, &(Handle)h, r);
	
}

void	setDlogUserItemProc(DialogRef d, short item, UserItemUPP proc)
{
	short		t;
	Handle		h;
	Rect			r;
	
	GetDialogItem(d, item, &t, &(Handle)h, &r);
	
	SetDialogItem(d, item, kUserDialogItem, (Handle)proc, &r);
}

pascal	void	threeDBoxUserItemProc(DialogRef d, short i)
{
	Rect		r;
	
	getDlogItemRect(d, i, &r);
	draw3DBox(&r, true);
}

pascal	void	plainBoxUserItemProc(DialogRef d, short i)
{
	Rect			r;
	PenState		oldPen;
	RGBColor		oldFore, black = {0x0000, 0x0000, 0x0000};
	
	getDlogItemRect(d, i, &r);
	
	GetPenState(&oldPen);
	GetForeColor(&oldFore);
	
	PenNormal();
	RGBForeColor(&black);
	FrameRect(&r);
	
	SetPenState(&oldPen);
	RGBForeColor(&oldFore);
}

void			setDlogItemHandle(DialogRef d, short i, Handle h)
{
	short		t;
	Handle		fh;
	Rect			r;
	
	GetDialogItem(d,  i, &t, &fh, &r);
	
	SetDialogItem(d,  i, t, h, &r);
}

short		getDlogRadioSet(DialogRef d, short first, short last)
{
	short	i;
	short	on = -1;
	
	for (i = first; i <= last; i++)
		if (getRadio(getDlogControl(d, i)))
			on = i;
			
	return on;
}

void		setDlogRadioSet(DialogRef d, short first, short last, short click)
{
	short	i;
	
	for (i = first; i <= last; i++)
		if (i == click)
			setRadio(getDlogControl(d, i), true);
		else
			setRadio(getDlogControl(d, i), false);
}

void		setDialogItemVisibility(DialogRef d, short item, Boolean show)
{
	short		t;
	Handle		h;
	Rect			r;
	
	GetDialogItem(d, item, &t, &(Handle)h, &r);

	if (show)
		ShowDialogItem(d, item);
	else
		HideDialogItem(d, item);
	
	if ((t <= 7) && (t >= 4))
	{
		if (show)
			ShowControl((ControlRef)h);	//	assumed
		else
			HideControl((ControlRef)h);
	}
}

void	getDialogText(DialogRef d, short item, Str255 txt)
{
	Handle		h = getDlogItemHandle(d, item);
	
	GetDialogItemText(h, txt);
}

void	setDialogText(DialogRef d, short item, Str255 txt)
{
	Handle		h = getDlogItemHandle(d, item);
	
	SetDialogItemText(h, txt);
}

//	questionDialog() requires DLOG & DITL
Boolean	questionDialog(short list, short index, short dlogId, Str255 param1)
{
	DialogRef		d = nil;
	OSErr		err;
	short		item = 0;
	Str255		question;
	
	GetIndString(question, list, index);
	ParamText(question, param1, "\p", "\p");
	
	d = GetNewDialog(dlogId, nil, (WindowRef)-1L);
	if (!d)
		return true;
	
	err = SetDialogDefaultItem(d, kStdOkItemIndex);
	err = SetDialogCancelItem(d, kStdCancelItemIndex);
	
	ShowWindow(d);
	
	while (!item)
		ModalDialog(nil, &item);
		
	DisposeDialog(d);
	
	return (item == kStdOkItemIndex);
}

void	initDlogPopup(DialogRef d, short i, short iv)
{
	ControlRef		ch;
	
	ch = getDlogControl(d, i);
	
	SetControlMinimum(ch, 1);
	SetControlMaximum(ch, CountMItems(getPopupsMenu(ch)));
	SetControlValue(ch, iv);
}