/*========================================================
File:			QuickChar.c
By:			Alastair Matthews
For:			Any application
Purpose:		QuickChar support routines
========================================================*/

/*	Please see QC.h or the files in the SDK folder for
	details on how to use these routines.
	
	You may modify this code if you wish (I don't know why anybody would
	want to), but please don't distribute your modified versions.
	
	1997 Alastair Matthews
*/

#include		"QuickChar.h"

//	Two local global variables
Boolean			gQCharInstalled;
QCharAddressTable	*gQCharAddrTable;

void		QCharInit(void)
{
	OSErr	err = noErr;
	
	err = Gestalt(gestaltQCharAddrTable, (long *)&gQCharAddrTable);
	if (err)
		gQCharInstalled = false;
	else
		gQCharInstalled = gQCharAddrTable->versionNumber >= kCurTableVersion;
		
}

Boolean	QCharInstalled(void)	//	doesn't work via global
{
	long			foo;
	
	if (Gestalt(gestaltQCharAddrTable, &foo) != noErr)
		return false;
		
	return ((QCharAddressTable *)foo)->versionNumber >= kCurTableVersion;
}

void		QCharSetFont(short inFontNumber)
{
	if (!gQCharInstalled)		return;

	gQCharAddrTable->devFont = inFontNumber;
	gQCharAddrTable->devFontChanged = true;
}

void		QCharSetAware(Boolean inAware)
{
	if (!gQCharInstalled)		return;
	
	gQCharAddrTable->devFontSet = inAware;
}