/*========================================================
File:			QuikChar.h
By:			Alastair Matthews
For:			Any application
Purpose:		Header for QuikChar.c
========================================================*/

#ifndef		_QCHAR_

#define		_QCHAR_

/*
	1997 Alastair Matthews	
	See note in QuickChar.c for modification info
*/

/*
	Here follows the QuickChar address table and related constants.
	Your code shouldn't read this table directly!
	
	Getting the table (snippet):
		QCharAddressTable *at; Gestalt(gestaltQCharAddrTable, (long *) &at);
*/

/*	Gestalt selector for accessing the address table	*/
#define		gestaltQCharAddrTable			'BLui'

/*	Table version numbers					*/
#define		kCurTableMagic		0x1E2F
#define		kCurTableVersion	0x0002

/*	The table	*/
#pragma options align = mac68k

typedef struct
{	
	long			magicNumber;
	long			versionNumber;
	
	ProcPtr		theTable[2];		
	
	/*SLHandle*/Handle		keystrokeTable;
	
	/*prefsHandle*/Handle		prefs;
	
	Boolean		recording;
	
	short			expansionPos;
	Boolean		areExpanding;
	Boolean		catchExpansions;
	
	Boolean		prefsOpen;
	short			prefsRefNum;		
	
	Boolean		floatCharReady;
	
	Boolean		prefsStatusChanged;
	
	Boolean		devFontSet;
	short			devFont;
	Boolean		devFontChanged;
	
	char			floatChar;
	OSType		keyApp;	
	
	FSSpec		prefsFile;
	FSSpec		cdevFile;
	Str255		curExpansion;
	Str255		macro;

} QCharAddressTable;

#pragma options align = reset

/*	Initialisation routine lets QuickChar.c check if QuickChar is installed		*/
void		QCharInit(void);

/*	Routine for checking is QuickChar installed. All calls made to QuickCharC.c functions check for QuickChar anyway, but this
	is here in case you need it.	*/
Boolean	QCharInstalled(void);

/*	Update active font. This also sets the font changed flag	*/
void		QCharSetFont(short inFontNumber);

/*	Set/unset QC-aware flag	*/
void		QCharSetAware(Boolean inAware);

#endif